<p>If a session ID can be guessed (not generated with a secure pseudo random generator, or with insufficient length …​) an attacker may be able to
hijack another user’s session.</p>
<h2>Ask Yourself Whether</h2>
<ul>
  <li> the session ID is not unique. </li>
  <li> the session ID is set from a user-controlled input. </li>
  <li> the session ID is generated with not secure pseudo random generator. </li>
  <li> the session ID length is too short. </li>
</ul>
<p>There is a risk if you answered yes to any of those questions.</p>
<h2>Recommended Secure Coding Practices</h2>
<p>Don’t manually generate session IDs, use instead language based native functionality.</p>
<h2>Sensitive Code Example</h2>
<pre>
session_id(bin2hex(random_bytes(4))); // Sensitive: 4 bytes is too short
session_id($_POST["session_id"]); // Sensitive: session ID can be specified by the user
</pre>
<h2>Compliant Solution</h2>
<pre>
session_regenerate_id(); ; // Compliant
session_id(bin2hex(random_bytes(16))); // Compliant
</pre>
<h2>See</h2>
<ul>
  <li> OWASP - <a href="https://owasp.org/Top10/A04_2021-Insecure_Design/">Top 10 2021 Category A4 - Insecure Design</a> </li>
  <li> OWASP - <a href="https://owasp.org/Top10/A07_2021-Identification_and_Authentication_Failures/">Top 10 2021 Category A7 - Identification and
  Authentication Failures</a> </li>
  <li> OWASP - <a href="https://owasp.org/www-project-top-ten/2017/A6_2017-Security_Misconfiguration">Top 10 2017 Category A6 - Security
  Misconfiguration</a> </li>
  <li> <a href="https://owasp.org/www-community/attacks/Session_fixation">OWASP Sesssion Fixation</a> </li>
  <li> CWE - <a href="https://cwe.mitre.org/data/definitions/330">CWE-330 - Use of Insufficiently Random Values</a> </li>
  <li> CWE - <a href="https://cwe.mitre.org/data/definitions/340">CWE-340 - Generation of Predictable Numbers or Identifiers</a> </li>
  <li> <a href="https://www.php.net/random-bytes">PHP: random_bytes()</a> </li>
  <li> <a href="https://www.php.net/session-regenerate-id">PHP: session_regenerate_id()</a> </li>
</ul>

